using System.Collections.Generic;

namespace CheesyFX
{
    public class Morph2Morph : MVRScript
    {
        private DAZMorph driverMorph;
        private Dictionary<DAZMorph, float> targetMorphs = new Dictionary<DAZMorph, float>();

        public override void Init()
        {
            var dcs = containingAtom.GetStorableByID("geometry") as DAZCharacterSelector;
            var morphControl = dcs.morphsControlUI;

            //customize here-------------
            
            // Target Atom with the morphs to be driven
            var targetAtom = SuperController.singleton.GetAtomByUid("<<UidOfTheAtomContainingTheTargetMorphs>>");
            
            var dcs2 = targetAtom.GetStorableByID("geometry") as DAZCharacterSelector;
            var morphControl2 = dcs2.morphsControlUI;
            
            
            // Morph to drive the others. Enter the exact morphs uid.
            driverMorph = morphControl.GetMorphByUid("<<MyDriverMorphUid>>");
            
            // Target morphs. Add more if you want. With the float entry (1f) you can adjust the scale between the driver and this specific morph.
            targetMorphs.Add(morphControl2.GetMorphByUid("<<MyTargetMorph1_Uid>>"), 1f);
            targetMorphs.Add(morphControl2.GetMorphByUid("<<MyTargetMorph2_Uid>>"), 1f);
        }

        public void Update()
        {
            foreach (var item in targetMorphs)
            {
                item.Key.morphValue = driverMorph.morphValue * item.Value;
            }
        }
    }
}